osl::effect_action::BetterToPromote< Action > Class Template Reference

成った方が良い駒は成る手のみ生成 More...

`#include <effect_action.h>`

## Public Member Functions

| BetterToPromote (const NumEffectState &s, Action &a)
template<Player P, Ptype Type>
void | doActionPtype (Piece p1, Square to)
template<Player P>
void | doAction (Piece p1, Square to)
| Ptypeをtemplate引数にできない場合

## Private Attributes

const NumEffectState & | state
Action & | ac

## Detailed Description

template<class Action>
class osl::effect_action::BetterToPromote< Action >

成った方が良い駒は成る手のみ生成

Definition at line 78 of file effect_action.h.

## Constructor & Destructor Documentation

## BetterToPromote()

template<class Action>

osl::effect_action::BetterToPromote< Action >::BetterToPromote | ( | const NumEffectState & | s,
|  | Action & | a )

inline

Definition at line 84 of file effect_action.h.

References ac, and state.

## Member Function Documentation

## doAction()

template<class Action>
template<Player P>

void osl::effect_action::BetterToPromote< Action >::doAction | ( | Piece | p1,
|  | Square | to )

inline

Ptypeをtemplate引数にできない場合

Definition at line 112 of file effect_action.h.

References ac, osl::PtypePlayerTraits< T, P >::canDropTo(), osl::canPromote(), osl::Square::canPromote(), osl::LANCE, osl::promote(), osl::Piece::ptype(), osl::Ptype_Table, osl::Piece::square(), and state.

## doActionPtype()

template<class Action>
template<Player P, Ptype Type>

void osl::effect_action::BetterToPromote< Action >::doActionPtype | ( | Piece | p1,
|  | Square | to )

inline

Definition at line 89 of file effect_action.h.

References ac, osl::PtypePlayerTraits< T, P >::canDropTo(), osl::canPromote(), osl::Square::canPromote(), osl::Piece::isPromotedNotKingGold(), osl::LANCE, osl::promote(), osl::Piece::ptype(), osl::Piece::square(), state, and osl::unpromote().

## Member Data Documentation

## ac

template<class Action>

Action& osl::effect_action::BetterToPromote< Action >::ac

private

Definition at line 82 of file effect_action.h.

Referenced by BetterToPromote(), doAction(), and doActionPtype().

## state

template<class Action>

const NumEffectState& osl::effect_action::BetterToPromote< Action >::state

private

Definition at line 81 of file effect_action.h.

Referenced by BetterToPromote(), doAction(), and doActionPtype().

The documentation for this class was generated from the following file:

- effect_action.h